// $Id: StringSetting.cc 11587 2010-07-13 21:55:48Z mthuurne $

#include "StringSetting.hh"

using std::string;

namespace openmsx {

// class StringSettingPolicy

StringSettingPolicy::StringSettingPolicy()
{
}

const string& StringSettingPolicy::toString(const string& value) const
{
	return value;
}

const string& StringSettingPolicy::fromString(const string& str) const
{
	return str;
}

string StringSettingPolicy::getTypeString() const
{
	return "string";
}

// class StringSetting

StringSetting::StringSetting(CommandController& commandController,
                             const string& name, const string& description,
                             const string& initialValue, SaveSetting save)
	: SettingImpl<StringSettingPolicy>(
		commandController, name, description, initialValue, save)
{
}

StringSetting::StringSetting(CommandController& commandController,
                             const char* name, const char* description,
                             const char* initialValue, SaveSetting save)
	: SettingImpl<StringSettingPolicy>(
		commandController, name, description, initialValue, save)
{
}

} // namespace openmsx
